 [ SNES9X
	INCLUDE 65816mac.h
	INCLUDE memory.h
	INCLUDE io.h

	IMPORT S9xResetCPU ;from 9x_cpu.c

	EXPORT reset_cpu
	EXPORT vcount
	EXPORT vtime
	EXPORT vtimetemp
	EXPORT timeup
	EXPORT vcount_latch
	EXPORT S9xGetByte
	EXPORT S9xGetWord
	EXPORT S9xSetByte
	EXPORT S9xSetWord
	EXPORT translate_addr
	EXPORT do_post_vblank

	AREA iwram, CODE, READWRITE

;(don't rearrange this stuff.. offsets are hardcoded in some places)
vcount DCD 0		;(current scanline)
vtime DCD 0		;(4209)
vtimetemp DCW 0		;(see w4209)
timeup DCW 0		;(4211)
vcount_latch DCD 0	;(213d)

;------------------------------------------
	AREA rom, CODE, READONLY
;------------------------------------------
ADR_TYPE SETA _ABS
S9xGetByte			;uint8 S9xGetByte (uint32 Address)
	stmfd sp!,{snes_a,snes_memtbl,lr}
	mov snes_a,#0
	ldr snes_memtbl,=readmem8_tbl
	mov snes_memtbl,snes_memtbl,lsr#2
	mov r12,r0
	readmem8
	ldmfd sp!,{snes_a,snes_memtbl,lr}
	bx lr
S9xGetWord			;uint16 S9xGetWord (uint32 Address)
	stmfd sp!,{snes_a,snes_memtbl,lr}
	mov snes_a,#0
	ldr snes_memtbl,=readmem8_tbl
	mov snes_memtbl,snes_memtbl,lsr#2
	mov r12,r0
	readmem16
	orr r0,r1,r0,lsl#8
	ldmfd sp!,{snes_a,snes_memtbl,lr}
	bx lr
S9xSetByte			;void S9xSetWord (uint16 Word, uint32 Address)
	stmfd sp!,{snes_a,snes_memtbl,lr}
	mov snes_a,#0
	ldr snes_memtbl,=readmem8_tbl
	mov snes_memtbl,snes_memtbl,lsr#2
	mov r12,r1
	writemem8
	ldmfd sp!,{snes_a,snes_memtbl,lr}
	bx lr
S9xSetWord			;void S9xSetByte (uint8 Byte, uint32 Address)
	stmfd sp!,{snes_a,snes_memtbl,lr}
	mov snes_a,#0
	ldr snes_memtbl,=readmem8_tbl
	mov snes_memtbl,snes_memtbl,lsr#2
	mov r12,r1
	writemem16
	ldmfd sp!,{snes_a,snes_memtbl,lr}
	bx lr
translate_addr			;turn snes ptr into GBA ptr
	stmfd sp!,{snes_a,snes_memtbl,lr}
	mov snes_a,#0
	ldr snes_memtbl,=readmem8_tbl
	mov snes_memtbl,snes_memtbl,lsr#2
	mov r12,r0
	translateR12
	mov r0,r1
	ldmfd sp!,{snes_a,snes_memtbl,lr}
	bx lr
do_post_vblank
	stmfd sp!,{lr}
	adr lr,asdf
	ldr pc,=post_vblank_process
asdf	ldmfd sp!,{lr}
	bx lr

reset_cpu	;called by hardreset (65816.s)
	ldr r0,=S9xResetCPU
	bx r0
;------------------------------------------
 ]
	END