	INCLUDE equates.h
	INCLUDE io.h

	EXPORT resetmem
	EXPORT readmem8_tbl
	EXPORT rom00_R8
	EXPORT rom00_R16
	EXPORT empty_R
	EXPORT empty_W
	EXPORT snes_rom_ptr

	AREA iwram, CODE, READWRITE

; See read/write macros in 65816mac.h for calling conventions.
;----------------------------------------------------------------------------
sram30_R8
sram30_R16
empty_R
	mov r0,#0
sram30_W8
sram30_W16
empty_W
	mov pc,lr
;----------------------------------------------------------------------------
ram8K_R8
	bic r1,r12,#0x00ff0000
	orr r1,r1,#SNES_RAM
	ldrb r0,[r1]
	mov pc,lr
ram8K_R16
	bic r0,r12,#0x00ff0000
	orr r0,r0,#SNES_RAM
	ldrb r1,[r0]
	ldrb r0,[r0,#1]
	mov pc,lr
;----------------------------------------------------------------------------
ram8K_W8
	bic r1,r12,#0x00ff0000
	orr r1,r1,#SNES_RAM
	strb r0,[r1]
	mov pc,lr
ram8K_W16
	bic r1,r12,#0x00ff0000
	orr r1,r1,#SNES_RAM
	strb r0,[r1]
	mov r0,r0,lsr#8
	strb r0,[r1,#1]
	mov pc,lr
;----------------------------------------------------------------------------
ram128K_R8
	bic r1,r12,#0x00fe0000
	orr r1,r1,#SNES_RAM
	ldrb r0,[r1]
	mov pc,lr
ram128K_R16
	bic r0,r12,#0x00fe0000
	orr r0,r0,#SNES_RAM
	ldrb r1,[r0]
	ldrb r0,[r0,#1]
	mov pc,lr
;----------------------------------------------------------------------------
ram128K_W8
	bic r1,r12,#0x00fe0000
	orr r1,r1,#SNES_RAM
	strb r0,[r1]
	mov pc,lr
ram128K_W16
	bic r1,r12,#0x00fe0000
	orr r1,r1,#SNES_RAM
	strb r0,[r1]
	mov r0,r0,lsr#8
	strb r0,[r1,#1]
	mov pc,lr
;----------------------------------------------------------------------------
sram70_R8	;700000-7d7fff
	mov r0,r12,lsl#19		;8k sram
	mov r1,#SNES_SRAM
	ldrb r0,[r1,r0,lsr#19]!
	mov pc,lr
sram70_R16
	mov r1,r12,lsl#19
	mov r0,#SNES_SRAM
	ldrb r1,[r0,r1,lsr#19]!
	ldrb r0,[r0,#1]
	mov pc,lr
;----------------------------------------------------------------------------
sram70_W8	;700000-7d7fff
	nop ;mov r2,r12,lsl#19 (resetmem changes this)
	mov r1,#SNES_SRAM
	strb r0,[r1,r2,lsr#19]
	mov pc,lr
sram70_W16
	nop ;mov r2,r12,lsl#19
	mov r1,#SNES_SRAM
	strb r0,[r1,r2,lsr#19]!
	mov r0,r0,lsr#8
	strb r0,[r1,#1]
	mov pc,lr
;----------------------------------------------------------------------------
rom00_mode20_R8	;008000-7dffff
	ldr r1,snes_rom_ptr_sub8000-(rom00_R8-rom00_mode20_R8)
	mov r0,r12,lsl#16
	add r0,r12,r0,lsr#16
	ldrb r0,[r1,r0,lsr#1]!
	mov pc,lr
rom00_mode20_R16
	ldr r0,snes_rom_ptr_sub8000-(rom00_R16-rom00_mode20_R16)
	mov r1,r12,lsl#16
	add r1,r12,r1,lsr#16
	ldrb r1,[r0,r1,lsr#1]!
	ldrb r0,[r0,#1]
	mov pc,lr
;----------------------------------------------------------------------------
rom00_mode21_R8	;008000-3fffff
	ldr r1,snes_rom_ptr-(rom00_R8-rom00_mode21_R8)
	bic r0,r12,#0xc00000
	ldrb r0,[r1,r0]!
	mov pc,lr
	nop ;make same size as lorom20_R8
rom00_mode21_R16
	ldr r1,snes_rom_ptr-(rom00_R16-rom00_mode21_R16)
	bic r0,r12,#0xc00000
	ldrb r1,[r0,r1]!
	ldrb r0,[r0,#1]
	mov pc,lr
;----------------------------------------------------------------------------
rom80_mode20_R8	;80xxxx-ffxxxx
	ldr r1,snes_rom_ptr_sub408000-(rom80_R8-rom80_mode20_R8)
	mov r0,r12,lsl#16
	add r0,r12,r0,lsr#16
	ldrb r0,[r1,r0,lsr#1]!
	mov pc,lr
rom80_mode20_R16
	ldr r0,snes_rom_ptr_sub408000-(rom80_R16-rom80_mode20_R16)
	mov r1,r12,lsl#16
	add r1,r12,r1,lsr#16
	ldrb r1,[r0,r1,lsr#1]!
	ldrb r0,[r0,#1]
	mov pc,lr
;----------------------------------------------------------------------------
rom80_mode21_R8
	ldr r1,snes_rom_ptr-(rom80_R8-rom80_mode21_R8)
	bic r0,r12,#0xc00000
	ldrb r0,[r1,r0]!
	mov pc,lr
	nop ;make same size as lorom20_R8
rom80_mode21_R16
	ldr r1,snes_rom_ptr-(rom80_R16-rom80_mode21_R16)
	bic r0,r12,#0xc00000
	ldrb r1,[r0,r1]!
	ldrb r0,[r0,#1]
	mov pc,lr
;----------------------------------------------------------------------------
rom00_R8			% 20	;initialized by resetmem
rom00_R16		% 24
rom80_R8			% 20
rom80_R16		% 24

snes_rom_ptr		DCD 0
snes_rom_ptr_sub8000	DCD 0	;snes_rom_ptr - 0x8000
snes_rom_ptr_sub408000	DCD 0	;snes_rom_ptr - 0x408000
;----------------------------------------------------------------------------
	AREA rom, CODE, READONLY
resetmem			;called from hardreset, r0=rom_ptr, r1=flags

	ldr r2,=snes_rom_ptr	;init ptrs
	str r0,[r2],#4
	sub r0,r0,#0x8000
	str r0,[r2],#4
	sub r0,r0,#0x400000
	str r0,[r2],#4

	tst r1,#SRAM		;got SRAM?
	ldreq r0,ret
	ldrne r0,sram70write
	ldr r2,=sram70_W8
	ldr r3,=sram70_W16
	str r0,[r2]
	str r0,[r3]

	tst r1,#HIROM		;cart type?

	ldreq r11,=rom00_mode20_R8
	ldrne r11,=rom00_mode21_R8
	ldr r12,=rom00_R8
	ldmia r11,{r0-r10}	;(44 bytes)
	stmia r12,{r0-r10}

	ldreq r11,=rom80_mode20_R8
	ldrne r11,=rom80_mode21_R8
	ldr r12,=rom80_R8
	ldmia r11,{r0-r10}	;(44 bytes)
	stmia r12,{r0-r10}

	fill 0x2000000,zero,0x20000	;clear ram
ret
	mov pc,lr
sram70write
	mov r2,r12,lsl#19
zero	DCD 0
;----------------------------------------------------------------------------
	LTORG

	MACRO
	REPT $count,$w0,$w1,$w2,$w3,$w4,$w5,$w6,$w7
	LCLA cnt
cnt 	SETA $count
	WHILE cnt > 0
	DCD $w0,$w1,$w2,$w3,$w4,$w5,$w6,$w7
cnt 	SETA cnt-1
	WEND
	MEND

readmem8_tbl
	REPT 0x30,ram8K_R8,io_R8,io_R8,empty_R,rom00_R8,rom00_R8,rom00_R8,rom00_R8			;00-2f
	REPT 0x10,ram8K_R8,io_R8,io_R8,sram30_R8,rom00_R8,rom00_R8,rom00_R8,rom00_R8			;30-3f
	REPT 0x30,empty_R,empty_R,empty_R,empty_R,rom00_R8,rom00_R8,rom00_R8,rom00_R8			;40-6f
	REPT 14,sram70_R8,sram70_R8,sram70_R8,sram70_R8,rom00_R8,rom00_R8,rom00_R8,rom00_R8		;70-7d
	REPT 2,ram128K_R8,ram128K_R8,ram128K_R8,ram128K_R8,ram128K_R8,ram128K_R8,ram128K_R8,ram128K_R8	;7e-7f
	REPT 0x40,ram8K_R8,io_R8,io_R8,empty_R,rom80_R8,rom80_R8,rom80_R8,rom80_R8			;80-bf
	REPT 0x40,rom80_R8,rom80_R8,rom80_R8,rom80_R8,rom80_R8,rom80_R8,rom80_R8,rom80_R8		;c0-ff
readmem16_tbl
	REPT 0x30,ram8K_R16,io_R16,io_R16,empty_R,rom00_R16,rom00_R16,rom00_R16,rom00_R16
	REPT 0x10,ram8K_R16,io_R16,io_R16,sram30_R16,rom00_R16,rom00_R16,rom00_R16,rom00_R16
	REPT 0x30,empty_R,empty_R,empty_R,empty_R,rom00_R16,rom00_R16,rom00_R16,rom00_R16
	REPT 14,sram70_R16,sram70_R16,sram70_R16,sram70_R16,rom00_R16,rom00_R16,rom00_R16,rom00_R16
	REPT 2,ram128K_R16,ram128K_R16,ram128K_R16,ram128K_R16,ram128K_R16,ram128K_R16,ram128K_R16,ram128K_R16
	REPT 0x40,ram8K_R16,io_R16,io_R16,empty_R,rom80_R16,rom80_R16,rom80_R16,rom80_R16
	REPT 0x40,rom80_R16,rom80_R16,rom80_R16,rom80_R16,rom80_R16,rom80_R16,rom80_R16,rom80_R16
writemem8_tbl
	REPT 0x30,ram8K_W8,io_W8,io_W8,empty_W,empty_W,empty_W,empty_W,empty_W
	REPT 0x10,ram8K_W8,io_W8,io_W8,sram30_W8,empty_W,empty_W,empty_W,empty_W
	REPT 0x30,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W
	REPT 14,sram70_W8,sram70_W8,sram70_W8,sram70_W8,empty_W,empty_W,empty_W,empty_W
	REPT 2,ram128K_W8,ram128K_W8,ram128K_W8,ram128K_W8,ram128K_W8,ram128K_W8,ram128K_W8,ram128K_W8
	REPT 0x40,ram8K_W8,io_W8,io_W8,empty_W,empty_W,empty_W,empty_W,empty_W
	REPT 0x40,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W
writemem16_tbl
	REPT 0x30,ram8K_W16,io_W16,io_W16,empty_W,empty_W,empty_W,empty_W,empty_W
	REPT 0x10,ram8K_W16,io_W16,io_W16,sram30_W16,empty_W,empty_W,empty_W,empty_W
	REPT 0x30,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W
	REPT 14,sram70_W16,sram70_W16,sram70_W16,sram70_W16,empty_W,empty_W,empty_W,empty_W
	REPT 2,ram128K_W16,ram128K_W16,ram128K_W16,ram128K_W16,ram128K_W16,ram128K_W16,ram128K_W16,ram128K_W16
	REPT 0x40,ram8K_W16,io_W16,io_W16,empty_W,empty_W,empty_W,empty_W,empty_W
	REPT 0x40,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W,empty_W
	END
